<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.sysarea_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/sysarea/sysarea";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "编号",
              prop: "code",
              rules: [{
                required: true,
                message: "请输入编号",
                trigger: "blur"
              }]
            },
            {
              label: "父级编号",
              prop: "parentCode",
              rules: [{
                required: true,
                message: "请输入父级编号",
                trigger: "blur"
              }]
            },
            {
              label: "名称",
              prop: "name",
              rules: [{
                required: true,
                message: "请输入名称",
                trigger: "blur"
              }]
            },
            {
              label: "简写名称",
              prop: "shortName",
              rules: [{
                required: true,
                message: "请输入简写名称",
                trigger: "blur"
              }]
            },
            {
              label: "繁体名字",
              prop: "traditionalName",
              rules: [{
                required: true,
                message: "请输入繁体名字",
                trigger: "blur"
              }]
            },
            {
              label: "英语名称",
              prop: "englishName",
              rules: [{
                required: true,
                message: "请输入英语名称",
                trigger: "blur"
              }]
            },
            {
              label: "省市区街道全称",
              prop: "mergerName",
              rules: [{
                required: true,
                message: "请输入省市区街道全称",
                trigger: "blur"
              }]
            },
            {
              label: "层级",
              prop: "layerNumber",
              rules: [{
                required: true,
                message: "请输入层级",
                trigger: "blur"
              }]
            },
            {
              label: "邮编",
              prop: "zipCode",
              rules: [{
                required: true,
                message: "请输入邮编",
                trigger: "blur"
              }]
            },
            {
              label: "城市编号",
              prop: "cityCode",
              rules: [{
                required: true,
                message: "请输入城市编号",
                trigger: "blur"
              }]
            },
            {
              label: "拼音",
              prop: "pinyin",
              rules: [{
                required: true,
                message: "请输入拼音",
                trigger: "blur"
              }]
            },
            {
              label: "伟度",
              prop: "lat",
              rules: [{
                required: true,
                message: "请输入伟度",
                trigger: "blur"
              }]
            },
            {
              label: "经度",
              prop: "lng",
              rules: [{
                required: true,
                message: "请输入经度",
                trigger: "blur"
              }]
            },
            {
              label: "首字母",
              prop: "firstLetter",
              rules: [{
                required: true,
                message: "请输入首字母",
                trigger: "blur"
              }]
            },
           
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.sysarea_add, false),
          viewBtn: this.vaildData(this.permission.sysarea_view, false),
          delBtn: this.vaildData(this.permission.sysarea_delete, false),
          editBtn: this.vaildData(this.permission.sysarea_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
